const join = require('path').join
const resolve = require('path').resolve
const loaderUtils = require('loader-utils')
const addRoutes = require('./routes/index')

module.exports = function () {
  const g = { // module defaults
    srcDir: '/content',
    dirs: ['/'],      // all files
    routePath: '',    // no route
    layout: 'default',
    permalink: ':slug',
    isPost: true,
  }

  const config = createConfig(this.options, g)

  this.options.build.loaders.push({ // convert markdown files to vue component
    test: /\.md$/,
    use: [
      { loader: 'vue-loader' },
      {
        loader: resolve(this.options.srcDir, '../lib/loader/index.js'), // TODO production path?
        options: { config }
      }
    ]
  })

  this.extendRoutes(routes => addRoutes(routes, config))
}

function createConfig (opts, g) {
  const config = Object.assign({}, g, opts.content) // merge options
  config.srcPath = join(opts.srcDir, config.srcDir)
  config.g = g
  // `config.dirs` can be an Array but for simplicity we only read it as a 2D Array
  if (!is2DArray(config.dirs)) config.dirs = [config.dirs]
  return config
}

function is2DArray (arr) {
  return Array.isArray(arr[0])
}
